//
//  OurFirstGameViewController.m
//  OurFirstGame
//
//  Created by Alex Nichol on 2/22/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "OurFirstGameViewController.h"

@implementation OurFirstGameViewController



/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

- (UIButton *)createNewButton {
	UIButton * clickMe = [[UIButton alloc] initWithFrame:CGRectMake(10, 10, 100, 100)];
	[clickMe addTarget:self action:@selector(buttonClick:) forControlEvents:UIControlEventTouchUpInside];
	[clickMe setBackgroundImage:[UIImage imageNamed:@"ball.png"] forState:UIControlStateNormal];
	[self.view addSubview:clickMe];
	
	CGRect buttonFrame = clickMe.frame;
	int randomX = arc4random() % (int)(320 - buttonFrame.size.width);
	int randomY = arc4random() % (int)(self.view.frame.size.height - buttonFrame.size.height);	
	
	buttonFrame.origin.x = randomX;
	buttonFrame.origin.y = randomY;
	clickMe.frame = buttonFrame;
	
	return clickMe;
}


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	
	// buttons = nil
	// buttonVels = nil
	buttons = [[NSMutableArray alloc] init];
	buttonVels = [[NSMutableArray alloc] init];
	// buttons = []
	// buttonVels = []
	UIButton * button1 = [self createNewButton];
	UIButton * button2 = [self createNewButton];
	UIButton * button3 = [self createNewButton];
	[buttons addObject:button1];
	[buttons addObject:button2];
	[buttons addObject:button3];
	// buttons = [button1, button2, button3]
	
	[buttonVels addObject:[NSValue valueWithCGPoint:CGPointMake(arc4random() % 4 + 2, arc4random() % 4 + 2)]];
	[buttonVels addObject:[NSValue valueWithCGPoint:CGPointMake(arc4random() % 4 + 2, arc4random() % 4 + 2)]];
	[buttonVels addObject:[NSValue valueWithCGPoint:CGPointMake(arc4random() % 4 + 2, arc4random() % 4 + 2)]];
	// buttonVels = [(4,4), (4,4), (4,4)]
	
	moveTimer = [NSTimer scheduledTimerWithTimeInterval:0.05 target:self 
											   selector:@selector(timerTick)
											   userInfo:nil
												repeats:YES];
}

- (void)timerTick {
	for (UIButton * clickMe in buttons) {
		int buttonIndex = [buttons indexOfObject:clickMe];
		NSValue * buttonVelVal = [buttonVels objectAtIndex:buttonIndex];
		CGPoint buttonVel = [buttonVelVal CGPointValue];
		// move the button
		CGRect buttonFrame = [clickMe frame];
		buttonFrame.origin.y += buttonVel.y;
		buttonFrame.origin.x += buttonVel.x;
		if (buttonFrame.origin.x < 0 || buttonFrame.origin.x + buttonFrame.size.width > self.view.frame.size.width) {
			buttonVel.x *= -1;
		}
		if (buttonFrame.origin.y < 0 || buttonFrame.origin.y + buttonFrame.size.height > self.view.frame.size.height) {
			buttonVel.y *= -1;
		}
		[clickMe setFrame:buttonFrame];
		[buttonVels replaceObjectAtIndex:buttonIndex withObject:[NSValue valueWithCGPoint:buttonVel]];
	}
}

- (IBAction)buttonClick:(UIButton *)sender {
	// tell the user they won.
	
	score += 50;
	[scoreLabel setText:[NSString stringWithFormat:@"Score: %d", score]];
	
	CGRect buttonFrame = sender.frame;
	int randomX = arc4random() % (int)(320 - buttonFrame.size.width);
	int randomY = arc4random() % (int)(self.view.frame.size.height - buttonFrame.size.height);	
		
	buttonFrame.origin.x = randomX;
	buttonFrame.origin.y = randomY;
	sender.frame = buttonFrame;
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

@end
